// priority: 0

// Visit the wiki for more info - https://kubejs.com/

// onEvent('recipes', event => {

    ServerEvents.recipes(event => {
        let incompleteAndesiteMechanism = 'kubejs:incomplete_andesite_mechanism'
        let incompleteCopperMechanism = 'kubejs:incomplete_copper_mechanism'
        let incompleteBrassMechanism = 'create:incomplete_precision_mechanism'
        let incompleteTrainMechanism = 'kubejs:incomplete_train_mechanism'
        let incompleteInvarMechanism = 'kubejs:incomplete_invar_mechanism'
        let incompleteSiliconMechanism = 'kubejs:incomplete_silicon_mechanism'
        let incompleteEnderMechanism = 'kubejs:incomplete_ender_mechanism'
    
        let stonecutting = (input, result, amount) => {
            event.custom({
                type: 'minecraft:stonecutting',
                count: amount,
                ingredient: {
                    item: input
                },
                result: result
            })
        }
    
        // Makeshift
        event.shapeless('kubejs:wooden_mechanism', ['3x #minecraft:logs', 'create:cogwheel', 'create:large_cogwheel', '2x minecraft:iron_nugget'])
    
        // Andesite Age
        event.recipes.create.sequenced_assembly([
            Item.of('kubejs:andesite_mechanism', 1)
        ], '#minecraft:wooden_slabs', [
            event.recipes.create.deploying(incompleteAndesiteMechanism, [incompleteAndesiteMechanism, 'thermal:iron_gear']),
            event.recipes.create.deploying(incompleteAndesiteMechanism, [incompleteAndesiteMechanism, '#minecraft:wooden_buttons']),
            event.recipes.create.pressing(incompleteAndesiteMechanism, [incompleteAndesiteMechanism])
        ]).transitionalItem(incompleteAndesiteMechanism).loops(1).id('bttk:sequenced_assembly/mechanism/andesite_mechanism')
    
        event.shaped('1x kubejs:andesite_machine', [
            'AAA',
            'ABA',
            'AAA'
        ], {
            A: 'kubejs:wooden_mechanism',
            B: '#forge:glass'
        }).id('bttk:machines/andesite_machine_from_wooden_mechanism')
    
        event.shaped('4x kubejs:andesite_machine', [
            'ABA',
            'BCB',
            'ABA'
        ], {
            A: 'create:andesite_casing',
            B: 'kubejs:andesite_mechanism',
            C: '#forge:glass'
        }).id('bttk:machines/andesite_machine')
    
        event.remove('create:crafting/kinetics/cogwheel')
        event.remove('create:deploying/cogwheel')
        event.remove('create:crafting/kinetics/large_cogwheel')
        event.remove('create:crafting/kinetics/large_cogwheel_from_little')
        event.remove('create:deploying/large_cogwheel')
        event.remove('create:crafting/kinetics/turntable')
        event.remove('create:crafting/kinetics/chute')
        event.remove('create:crafting/schematics/schematic_table')
        event.remove('create:crafting/kinetics/depot')
        event.remove('create:crafting/kinetics/encased_chain_drive')
        event.remove('create:crafting/kinetics/gearshift')
        event.remove('create:crafting/kinetics/clutch')
        event.remove('create:crafting/kinetics/adjustable_chain_gearshift')
        event.remove('create:crafting/kinetics/portable_storage_interface')
        event.remove('create:crafting/kinetics/gearbox')
        event.remove('create:crafting/kinetics/weighted_ejector')
        event.remove('create:crafting/kinetics/speedometer')
        event.remove('create:crafting/kinetics/stressometer')
        event.remove('create_connected:crafting/kinetics/six_way_gearbox')

        event.shaped('2x kubejs:andesite_template', [
            'ABA',
            'ACA',
            'AAA'
        ], {
            A: 'minecraft:diamond',
            B: 'kubejs:andesite_template',
            C: 'create:andesite_alloy'
        }).id('bttk:andesite_template_duplication')
    
        stonecutting('kubejs:andesite_machine', 'kubejs:andesite_template', 4)
        stonecutting('create:andesite_casing', 'create:cogwheel', 8)
        stonecutting('create:andesite_casing', 'create:large_cogwheel', 4)
        stonecutting('create:andesite_casing', 'create:turntable', 2)
        stonecutting('create:andesite_casing', 'create:chute', 2)
        stonecutting('create:andesite_casing', 'create:schematic_table', 1)
        stonecutting('create:andesite_casing', 'create:depot', 2)
        
        stonecutting('kubejs:andesite_machine', 'create:encased_chain_drive', 4)
        stonecutting('kubejs:andesite_machine', 'create:gearshift', 2)
        stonecutting('kubejs:andesite_machine', 'create:clutch', 2)
        stonecutting('kubejs:andesite_machine', 'create:adjustable_chain_gearshift', 2)
        stonecutting('kubejs:andesite_machine', 'create:portable_storage_interface', 2)
        stonecutting('kubejs:andesite_machine', 'create:gearbox', 2)
        stonecutting('kubejs:andesite_machine', 'create:weighted_ejector', 1)
        stonecutting('kubejs:andesite_machine', 'create:speedometer', 1)
        stonecutting('kubejs:andesite_machine', 'create:stressometer', 1)
        stonecutting('kubejs:andesite_machine', 'create_connected:six_way_gearbox', 1)
        
        event.remove('hibernalherbs:conjuration_altar')
        event.remove('create:crafting/kinetics/gantry_carriage')
        event.remove('create:crafting/kinetics/mechanical_bearing')
        event.shaped('create:gantry_carriage', [
            ' A ',
            ' B ',
            ' C '
        ], {
            A: '#minecraft:wooden_slabs',
            B: 'kubejs:andesite_machine',
            C: 'create:cogwheel'
        }).id('bttk:gantry_carriage')
        event.shaped('create:mechanical_bearing', [
            ' A ',
            ' B ',
            ' C '
        ], {
            A: '#minecraft:wooden_slabs',
            B: 'kubejs:andesite_machine',
            C: 'create:shaft'
        }).id('bttk:mechanical_bearing')
        event.shaped('hibernalherbs:conjuration_altar', [
            'ABA',
            'BCB',
            'ABA'
        ], {
            A: 'hibernalherbs:myqueste_planks',
            B: '#hibernalherbs:herbs',
            C: 'kubejs:andesite_machine'
        }).id('bttk:herbal_conjuration_altar')
        
        event.remove('create:crafting/kinetics/mechanical_press')
        event.remove('create:crafting/kinetics/mechanical_mixer')
        event.remove('create:crafting/kinetics/mechanical_saw')
        event.remove('create:crafting/kinetics/mechanical_drill')
        event.remove('create:crafting/kinetics/encased_fan')
        event.remove('create:crafting/kinetics/mechanical_piston')
        event.remove('create:crafting/kinetics/deployer')
        event.remove('create:crafting/kinetics/rope_pulley')
        event.remove('create:crafting/kinetics/contraption_controls')
        event.remove('create:crafting/kinetics/millstone')
        event.remove('create:crafting/kinetics/mechanical_plough')
        event.remove('create:crafting/kinetics/mechanical_harvester')
        event.remove('create:crafting/kinetics/mechanical_roller')
        event.remove('create:crafting/kinetics/mechanical_roller')
        // event.remove('create:mechanical_crafting/crushing_wheel')
        event.remove('createsifter:sifter')
        event.remove('thermal:device_tree_extractor')
        event.smithing('create:mechanical_press', 'kubejs:andesite_template', 'kubejs:andesite_machine', 'minecraft:iron_block').id('bttk:andesite_machine/mechanical_press')
        event.smithing('create:mechanical_mixer', 'kubejs:andesite_template', 'kubejs:andesite_machine', 'create:whisk').id('bttk:andesite_machine/mechanical_mixer')
        event.smithing('create:mechanical_saw', 'kubejs:andesite_template', 'kubejs:andesite_machine', 'thermal:saw_blade').id('bttk:andesite_machine/mechanical_saw')
        event.smithing('create:mechanical_drill', 'kubejs:andesite_template', 'kubejs:andesite_machine', 'thermal:drill_head').id('bttk:andesite_machine/mechanical_drill')
        event.smithing('create:encased_fan', 'kubejs:andesite_template', 'kubejs:andesite_machine', 'create:propeller').id('bttk:andesite_machine/encased_fan')
        event.smithing('create:mechanical_piston', 'kubejs:andesite_template', 'kubejs:andesite_machine', 'minecraft:piston').id('bttk:andesite_machine/mechanical_piston')
        event.smithing('create:deployer', 'kubejs:andesite_template', 'kubejs:andesite_machine', 'kubejs:gold_hand').id('bttk:andesite_machine/deployer')
        event.smithing('create:rope_pulley', 'kubejs:andesite_template', 'kubejs:andesite_machine', 'comforts:rope_and_nail').id('bttk:andesite_machine/rope_pulley')
        event.smithing('create:contraption_controls', 'kubejs:andesite_template', 'kubejs:andesite_machine', 'minecraft:lever').id('bttk:andesite_machine/contraption_controls')
        event.smithing('create:millstone', 'kubejs:andesite_template', 'kubejs:andesite_machine', 'minecraft:stone').id('bttk:andesite_machine/millstone')
        event.smithing('create:mechanical_plough', 'kubejs:andesite_template', 'kubejs:andesite_machine', '#forge:plates/iron').id('bttk:andesite_machine/mechanical_plough')
        event.smithing('create:mechanical_harvester', 'kubejs:andesite_template', 'kubejs:andesite_machine', '#forge:plates/silver').id('bttk:andesite_machine/mechanical_harvester')
        event.smithing('create:mechanical_roller', 'kubejs:andesite_template', 'kubejs:andesite_machine', 'create:crushing_wheel').id('bttk:andesite_machine/mechanical_roller')
        event.smithing('create:schematicannon', 'kubejs:andesite_template', 'kubejs:andesite_machine', 'create:empty_schematic').id('bttk:andesite_machine/schematic_cannon')
        event.smithing('createsifter:sifter', 'kubejs:andesite_template', 'kubejs:andesite_machine', 'createsifter:string_mesh').id('bttk:andesite_machine/andesite_sifter')
        event.smithing('thermal:device_tree_extractor', 'kubejs:andesite_template', 'kubejs:andesite_machine', 'create:fluid_tank').id('bttk:andesite_machine/arboreal_extractor')
    
        // Copper Age
        event.recipes.create.sequenced_assembly([
            Item.of('kubejs:copper_mechanism', 1)
        ], 'thermal:cured_rubber', [
            event.recipes.create.deploying(incompleteCopperMechanism, [incompleteCopperMechanism, 'thermal:iron_gear']),
            event.recipes.create.deploying(incompleteCopperMechanism, [incompleteCopperMechanism, 'thermal:iron_gear']),
            event.recipes.create.deploying(incompleteCopperMechanism, [incompleteCopperMechanism, '#forge:plates/copper']),
            event.recipes.create.pressing(incompleteCopperMechanism, [incompleteCopperMechanism])
        ]).transitionalItem(incompleteCopperMechanism).loops(1).id('bttk:sequenced_assembly/mechanism/copper_mechanism')
    
        event.shaped('4x kubejs:copper_machine', [
            'ABA',
            'BCB',
            'ABA'
        ], {
            A: 'create:copper_casing',
            B: 'kubejs:copper_mechanism',
            C: '#forge:glass'
        }).id('bttk:machines/copper_machine')
    
        event.remove('create:crafting/kinetics/fluid_tank')
        event.remove('create_connected:crafting/kinetics/fluid_vessel')
        event.remove('create:crafting/kinetics/portable_fluid_interface')

        event.shaped('2x kubejs:copper_template', [
            'ABA',
            'ACA',
            'AAA'
        ], {
            A: 'minecraft:diamond',
            B: 'kubejs:copper_template',
            C: 'minecraft:copper_ingot'
        }).id('bttk:copper_template_duplication')
    
        stonecutting('kubejs:copper_machine', 'kubejs:copper_template', 4)
       
        stonecutting('kubejs:copper_machine', 'create:fluid_tank', 4)
        stonecutting('kubejs:copper_machine', 'create_connected:fluid_vessel', 4)
        stonecutting('kubejs:copper_machine', 'create:portable_fluid_interface', 2)
    
        event.remove('create:crafting/kinetics/spout')
        event.remove('create_enchantment_industry:crafting/printer')
        event.shaped('create:spout', [
            ' A ',
            ' B '
        ], {
            A: 'kubejs:copper_machine',
            B: 'minecraft:dried_kelp'
        }).id('bttk:spout')
        event.shaped('create_enchantment_industry:printer', [
            ' A ',
            ' B ',
            ' C '
        ], {
            A: 'kubejs:copper_machine',
            B: 'minecraft:dried_kelp',
            C: '#forge:plates/iron'
        }).id('bttk:printer')
    
        event.remove('create:crafting/kinetics/steam_engine')
        event.remove('create:crafting/kinetics/hose_pulley')
        event.remove('create:crafting/kinetics/item_drain')
        event.remove('create_enchantment_industry:crafting/disenchanter')
        event.remove('thermal:fluid_cell_frame')
        event.smithing('create:steam_engine', 'kubejs:copper_template', 'kubejs:copper_machine', 'create:steam_whistle').id('bttk:copper_machine/steam_engine')
        event.smithing('create:hose_pulley', 'kubejs:copper_template', 'kubejs:copper_machine', 'comforts:rope_and_nail').id('bttk:copper_machine/hose_pulley')
        event.smithing('create:item_drain', 'kubejs:copper_template', 'kubejs:copper_machine', 'minecraft:hopper').id('bttk:copper_machine/item_drain')
        event.smithing('create_enchantment_industry:disenchanter', 'kubejs:copper_template', 'kubejs:copper_machine', 'create:experience_block').id('bttk:copper_machine/disenchanter')
        event.smithing('thermal:fluid_cell_frame', 'kubejs:copper_template', 'kubejs:copper_machine', 'minecraft:bucket').id('bttk:copper_machine/fluid_cell_frame')
    
        // Brass Age
        event.recipes.create.sequenced_assembly([
            Item.of('create:precision_mechanism', 1)
        ], 'create:brass_sheet', [
            event.recipes.create.deploying(incompleteBrassMechanism, [incompleteBrassMechanism, 'thermal:gold_gear']),
            event.recipes.create.deploying(incompleteBrassMechanism, [incompleteBrassMechanism, 'thermal:gold_gear']),
            event.recipes.create.deploying(incompleteBrassMechanism, [incompleteBrassMechanism, 'create:andesite_alloy']),
            event.recipes.create.pressing(incompleteBrassMechanism, [incompleteBrassMechanism])
        ]).transitionalItem(incompleteBrassMechanism).loops(1).id('bttk:sequenced_assembly/mechanism/brass_mechanism')
    
        event.shaped('4x kubejs:brass_machine', [
            'ABA',
            'BCB',
            'ABA'
        ], {
            A: 'create:brass_casing',
            B: 'create:precision_mechanism',
            C: '#forge:glass'
        }).id('bttk:machines/brass_machine')
    
        event.remove('create:crafting/kinetics/sequenced_gearshift')
    
        event.remove('create:crafting/kinetics/smart_chute')

        event.shaped('2x kubejs:brass_template', [
            'ABA',
            'ACA',
            'AAA'
        ], {
            A: 'minecraft:diamond',
            B: 'kubejs:brass_template',
            C: 'create:brass_ingot'
        }).id('bttk:brass_template_duplication')

        stonecutting('kubejs:brass_machine', 'kubejs:brass_template', 4)
        stonecutting('create:brass_casing', 'create:smart_chute', 2)
        stonecutting('kubejs:brass_machine', 'createaddition:portable_energy_interface', 2)
    
        stonecutting('kubejs:brass_machine', 'create:sequenced_gearshift', 2)
        
        event.remove('create:crafting/logistics/stockpile_switch')
        event.remove('create:crafting/logistics/content_observer')
        event.shaped('create:stockpile_switch', [
            ' A ',
            ' B ',
            ' C '
        ], {
            A: 'create:electron_tube',
            B: 'kubejs:brass_machine',
            C: 'minecraft:comparator'
        }).id('bttk:stockpile_swtich')
        event.shaped('create:content_observer', [
            ' A ',
            ' B ',
            ' C '
        ], {
            A: 'create:electron_tube',
            B: 'kubejs:brass_machine',
            C: 'minecraft:observer'
        }).id('bttk:content_observer')
    
        event.remove('create:crafting/kinetics/elevator_pulley')
        event.remove('create:crafting/kinetics/rotation_speed_controller')
        event.remove('create:crafting/kinetics/clockwork_bearing')
        event.remove('create:crafting/kinetics/mechanical_crafter')
        event.remove('create:crafting/kinetics/mechanical_arm')
        event.remove('create_connected:crafting/kinetics/empty_fan_catalyst')
        event.remove('garnishedstoneautomation:mechanical_extractor')
        event.remove('createsifter:brass_sifter')
        event.remove('createaddition:mechanical_crafting/tesla_coil')
        event.remove('createaddition:crafting/portable_energy_interface')
        event.smithing('create:elevator_pulley', 'kubejs:brass_template', 'kubejs:brass_machine', 'comforts:rope_and_nail').id('bttk:brass_machine/elevator_pulley')
        event.smithing('create:rotation_speed_controller', 'kubejs:brass_template', 'kubejs:brass_machine', 'create:large_cogwheel').id('bttk:brass_machine/rotation_speed_controller')
        event.smithing('create:clockwork_bearing', 'kubejs:brass_template', 'kubejs:brass_machine', 'minecraft:sticky_piston').id('bttk:brass_machine/clockwork_bearing')
        event.smithing('3x create:mechanical_crafter', 'kubejs:brass_template', 'kubejs:brass_machine', 'minecraft:crafting_table').id('bttk:brass_machine/mechanical_crafter')
        event.smithing('create:mechanical_arm', 'kubejs:brass_template', 'kubejs:brass_machine', 'create:brass_hand').id('bttk:brass_machine/mechanical_arm')
        event.smithing('create_connected:empty_fan_catalyst', 'kubejs:brass_template', 'kubejs:brass_machine', 'minecraft:iron_bars').id('bttk:brass_machine/empty_fan_catalyst')
        event.smithing('garnishedstoneautomation:mechanical_extractor', 'kubejs:brass_template', 'kubejs:brass_machine', 'minecraft:obsidian').id('bttk:brass_machine/mechanical_extractor')
        event.smithing('createsifter:brass_sifter', 'kubejs:brass_template', 'kubejs:brass_machine', 'createsifter:string_mesh').id('bttk:brass_machine/brass_sifter')
        event.smithing('createaddition:tesla_coil', 'kubejs:brass_template', 'kubejs:brass_machine', 'createaddition:copper_spool').id('bttk:brass_machine/tesla_coil')
    
        // Train Age
        event.recipes.create.sequenced_assembly([
            Item.of('kubejs:train_mechanism', 1)
        ], 'create:sturdy_sheet', [
            event.recipes.create.deploying(incompleteTrainMechanism, [incompleteTrainMechanism, 'create:large_cogwheel']),
            event.recipes.create.deploying(incompleteTrainMechanism, [incompleteTrainMechanism, 'kubejs:brass_gear']),
            event.recipes.create.deploying(incompleteTrainMechanism, [incompleteTrainMechanism, 'kubejs:brass_gear']),
            event.recipes.create.deploying(incompleteTrainMechanism, [incompleteTrainMechanism, 'create:andesite_alloy']),
            event.recipes.create.pressing(incompleteTrainMechanism, [incompleteTrainMechanism])
        ]).transitionalItem(incompleteTrainMechanism).loops(1).id('bttk:sequenced_assembly/mechanism/train_mechanism')
    
        event.shaped('4x kubejs:train_machine', [
            'ABA',
            'BCB',
            'ABA'
        ], {
            A: 'create:railway_casing',
            B: 'kubejs:train_mechanism',
            C: '#forge:glass'
        }).id('bttk:machines/train_machine')
    
        event.remove('create:crafting/kinetics/schedule')
        event.remove('railways:crafting/portable_fuel_interface')

        event.shaped('2x kubejs:train_template', [
            'ABA',
            'ACA',
            'AAA'
        ], {
            A: 'minecraft:diamond',
            B: 'kubejs:train_template',
            C: 'create:sturdy_sheet'
        }).id('bttk:train_template_duplication')

        stonecutting('create:railway_casing', 'create:schedule', 4)
        stonecutting('kubejs:train_machine', 'kubejs:train_template', 4)
        stonecutting('kubejs:train_machine', 'railways:portable_fuel_interface', 2)
    
        event.remove('create:crafting/kinetics/track_station')
        event.remove('create:crafting/kinetics/track_signal')
        event.remove('create:crafting/kinetics/track_observer')
        event.remove('create:crafting/kinetics/track_observer_from_other_plates')
        event.remove('create:crafting/kinetics/controls')
        event.remove('railways:crafting/track_coupler')
        event.smithing('2x create:track_station', 'kubejs:train_template', 'kubejs:train_machine', 'create:schedule').id('bttk:train_machine/track_station')
        event.smithing('2x create:track_signal', 'kubejs:train_template', 'kubejs:train_machine', 'minecraft:redstone_lamp').id('bttk:train_machine/track_signal')
        event.smithing('2x create:track_observer', 'kubejs:train_template', 'kubejs:train_machine', 'minecraft:observer').id('bttk:train_machine/track_observer')
        event.smithing('create:controls', 'kubejs:train_template', 'kubejs:train_machine', 'minecraft:lever').id('bttk:train_machine/controls')
        event.smithing('2x railways:track_coupler', 'kubejs:train_template', 'kubejs:train_machine', 'create:minecart_coupling').id('bttk:train_machine/track_coupler')
        
        // Invar Age
        event.recipes.create.sequenced_assembly([
            Item.of('kubejs:invar_mechanism', 1)
        ], '#forge:plates/invar', [
            event.recipes.create.deploying(incompleteInvarMechanism, [incompleteInvarMechanism, 'thermal:tin_nugget']),
            event.recipes.create.deploying(incompleteInvarMechanism, [incompleteInvarMechanism, 'create:zinc_nugget']),
            event.recipes.create.deploying(incompleteInvarMechanism, [incompleteInvarMechanism, 'thermal:silver_gear']),
            event.recipes.create.deploying(incompleteInvarMechanism, [incompleteInvarMechanism, 'thermal:silver_gear']),
            event.recipes.create.pressing(incompleteInvarMechanism, [incompleteInvarMechanism])
        ]).transitionalItem(incompleteInvarMechanism).loops(1).id('bttk:sequenced_assembly/mechanism/invar_mechanism')
    
        event.shaped('4x kubejs:invar_machine', [
            'ABA',
            'BCB',
            'ABA'
        ], {
            A: 'thermal:machine_frame',
            B: 'kubejs:invar_mechanism',
            C: '#forge:glass'
        }).id('bttk:machines/invar_machine')

        event.shaped('2x kubejs:invar_template', [
            'ABA',
            'ACA',
            'AAA'
        ], {
            A: 'minecraft:diamond',
            B: 'kubejs:invar_template',
            C: 'thermal:invar_ingot'
        }).id('bttk:invar_template_duplication')
    
        stonecutting('kubejs:invar_machine', 'kubejs:invar_template', 4)
    
        event.remove('thermal:machine_furnace')
        event.remove('thermal:machine_sawmill')
        event.remove('thermal:machine_pulverizer')
        event.remove('thermal:machine_smelter')
        event.remove('thermal:machine_insolator')
        event.remove('thermal:machine_centrifuge')
        event.remove('thermal:machine_press')
        event.remove('thermal:machine_crucible')
        event.remove('thermal:machine_chiller')
        event.remove('thermal:machine_refinery')
        event.remove('thermal:machine_bottler')
        event.remove('thermal:machine_pyrolyzer')
        event.remove('thermal:machine_brewer')
        event.remove('thermal:machine_crystallizer')
        event.remove('thermal:machine_crafter')
        event.remove('thermal:device_potion_diffuser')
        event.remove('thermal:device_collector')
        event.remove('thermal:device_nullifier')
        event.remove('thermal:device_rock_gen')
        event.smithing('thermal:machine_furnace', 'kubejs:invar_template', 'kubejs:invar_machine', 'minecraft:redstone_block').id('bttk:invar_machine/machine_furnace')
        event.smithing('thermal:machine_sawmill', 'kubejs:invar_template', 'kubejs:invar_machine', 'thermal:saw_blade').id('bttk:invar_machine/machine_sawmill')
        event.smithing('thermal:machine_pulverizer', 'kubejs:invar_template', 'kubejs:invar_machine', 'thermal:drill_head').id('bttk:invar_machine/machine_pulverizer')
        event.smithing('thermal:machine_smelter', 'kubejs:invar_template', 'kubejs:invar_machine', 'minecraft:blast_furnace').id('bttk:invar_machine/machine_smelter')
        event.smithing('thermal:machine_insolator', 'kubejs:invar_template', 'kubejs:invar_machine', '#minecraft:flowers').id('bttk:invar_machine/machine_insolator')
        event.smithing('thermal:machine_centrifuge', 'kubejs:invar_template', 'kubejs:invar_machine', 'minecraft:compass').id('bttk:invar_machine/machine_centrifuge')
        event.smithing('thermal:machine_press', 'kubejs:invar_template', 'kubejs:invar_machine', 'minecraft:iron_block').id('bttk:invar_machine/machine_press')
        event.smithing('thermal:machine_crucible', 'kubejs:invar_template', 'kubejs:invar_machine', 'minecraft:lava_bucket').id('bttk:invar_machine/machine_crucible')
        event.smithing('thermal:machine_chiller', 'kubejs:invar_template', 'kubejs:invar_machine', 'minecraft:packed_ice').id('bttk:invar_machine/machine_chiller')
        event.smithing('thermal:machine_refinery', 'kubejs:invar_template', 'kubejs:invar_machine', 'minecraft:bucket').id('bttk:invar_machine/machine_refinery')
        event.smithing('thermal:machine_bottler', 'kubejs:invar_template', 'kubejs:invar_machine', 'minecraft:glass_bottle').id('bttk:invar_machine/machine_bottler')
        event.smithing('thermal:machine_pyrolyzer', 'kubejs:invar_template', 'kubejs:invar_machine', 'minecraft:blaze_powder').id('bttk:invar_machine/machine_pyrolyzer')
        event.smithing('thermal:machine_brewer', 'kubejs:invar_template', 'kubejs:invar_machine', 'minecraft:brewing_stand').id('bttk:invar_machine/machine_brewer')
        event.smithing('thermal:machine_crystallizer', 'kubejs:invar_template', 'kubejs:invar_machine', 'minecraft:amethyst_cluster').id('bttk:invar_machine/machine_crystallizer')
        event.smithing('thermal:machine_crafter', 'kubejs:invar_template', 'kubejs:invar_machine', 'minecraft:crafting_table').id('bttk:invar_machine/machine_crafter')
        event.smithing('thermal:device_potion_diffuser', 'kubejs:invar_template', 'kubejs:invar_machine', 'minecraft:dragon_breath').id('bttk:invar_machine/machine_potion_diffuser')
        event.smithing('thermal:device_collector', 'kubejs:invar_template', 'kubejs:invar_machine', 'minecraft:hopper').id('bttk:invar_machine/machine_collector')
        event.smithing('thermal:device_nullifier', 'kubejs:invar_template', 'kubejs:invar_machine', 'minecraft:cactus').id('bttk:invar_machine/machine_nullifier')
        event.smithing('thermal:device_rock_gen', 'kubejs:invar_template', 'kubejs:invar_machine', 'minecraft:stone').id('bttk:invar_machine/machine_rock_gen')
        
        // Fluix/Silicon Age
        event.recipes.create.sequenced_assembly([
            Item.of('kubejs:silicon_mechanism', 1)
        ], 'ae2:silicon', [
            event.recipes.create.deploying(incompleteSiliconMechanism, [incompleteSiliconMechanism, 'ae2:fluix_dust']),
            event.recipes.create.deploying(incompleteSiliconMechanism, [incompleteSiliconMechanism, 'thermal:enderium_gear']),
            event.recipes.create.deploying(incompleteSiliconMechanism, [incompleteSiliconMechanism, 'thermal:enderium_gear']),
            event.recipes.create.deploying(incompleteSiliconMechanism, [incompleteSiliconMechanism, 'create:andesite_alloy']),
            event.recipes.create.pressing(incompleteSiliconMechanism, [incompleteSiliconMechanism])
        ]).transitionalItem(incompleteSiliconMechanism).loops(1).id('bttk:sequenced_assembly/mechanism/silicon_mechanism')
    
        event.recipes.create.item_application('kubejs:silicon_casing', ['ae2:quartz_block', 'kubejs:refined_silicon']).id('bttk:item_application/silicon_casing')
    
        event.shaped('4x kubejs:silicon_machine', [
            'ABA',
            'BCB',
            'ABA'
        ], {
            A: 'kubejs:silicon_casing',
            B: 'kubejs:silicon_mechanism',
            C: '#forge:glass'
        }).id('bttk:machines/silicon_machine')

        event.shaped('2x kubejs:silicon_template', [
            'ABA',
            'ACA',
            'AAA'
        ], {
            A: 'minecraft:diamond',
            B: 'kubejs:silicon_template',
            C: 'ae2:certus_quartz_crystal'
        }).id('bttk:silicon_template_duplication')
        
        stonecutting('kubejs:silicon_machine', 'kubejs:silicon_template', 4)
    
        event.remove('ae2:network/blocks/storage_chest')
        event.remove('ae2:network/blocks/interfaces_interface')
        event.remove('ae2:network/blocks/cell_workbench')
        event.remove('ae2:network/blocks/io_port')
        event.remove('ae2:network/blocks/io_condenser')
        event.remove('ae2:network/blocks/storage_drive')
        event.remove('ae2:network/blocks/energy_energy_acceptor')
        event.remove('ae2:network/crafting/cpu_crafting_unit')
        event.remove('ae2:network/crafting/cpu_crafting_monitor')
        event.remove('ae2:network/crafting/1k_cpu_crafting_storage')
        event.remove('ae2:network/crafting/4k_cpu_crafting_storage')
        event.remove('ae2:network/crafting/16k_cpu_crafting_storage')
        event.remove('ae2:network/crafting/64k_cpu_crafting_storage')
        event.remove('ae2:network/crafting/256k_cpu_crafting_storage')
        event.remove('ae2:network/crafting/cpu_crafting_accelerator')
        event.remove('ae2:network/blocks/controller')
        event.smithing('ae2:chest', 'kubejs:silicon_template', 'kubejs:silicon_machine', 'minecraft:chest').id('bttk:silicon_machine/storage_chest')
        event.smithing('ae2:interface', 'kubejs:silicon_template', 'kubejs:silicon_machine', 'minecraft:hopper').id('bttk:silicon_machine/interfaces_interface')
        event.smithing('ae2:cell_workbench', 'kubejs:silicon_template', 'kubejs:silicon_machine', 'ae2:item_cell_housing').id('bttk:silicon_machine/cell_workbench')
        event.smithing('ae2:io_port', 'kubejs:silicon_template', 'kubejs:silicon_machine', 'create:chute').id('bttk:silicon_machine/io_port')
        event.smithing('ae2:condenser', 'kubejs:silicon_template', 'kubejs:silicon_machine', 'minecraft:ender_pearl').id('bttk:silicon_machine/io_condenser')
        event.smithing('ae2:drive', 'kubejs:silicon_template', 'kubejs:silicon_machine', ['create:item_vault', 'create_connected:item_silo']).id('bttk:silicon_machine/storage_drive')
        event.smithing('ae2:energy_acceptor', 'kubejs:silicon_template', 'kubejs:silicon_machine', 'powah:steel_energized').id('bttk:silicon_machine/energy_energy_acceptor')
        event.smithing('ae2:crafting_unit', 'kubejs:silicon_template', 'kubejs:silicon_machine', 'minecraft:crafting_table').id('bttk:silicon_machine/cpu_crafting_unit')
        event.smithing('ae2:crafting_monitor', 'kubejs:silicon_template', 'kubejs:silicon_machine', 'ae2:storage_monitor').id('bttk:silicon_machine/cpu_crafting_monitor')
        event.smithing('ae2:1k_crafting_storage', 'kubejs:silicon_template', 'kubejs:silicon_machine', 'ae2:cell_component_1k').id('bttk:silicon_machine/1k_cpu_crafting_storage')
        event.smithing('ae2:4k_crafting_storage', 'kubejs:silicon_template', 'kubejs:silicon_machine', 'ae2:cell_component_4k').id('bttk:silicon_machine/4k_cpu_crafting_storage')
        event.smithing('ae2:16k_crafting_storage', 'kubejs:silicon_template', 'kubejs:silicon_machine', 'ae2:cell_component_16k').id('bttk:silicon_machine/16k_cpu_crafting_storage')
        event.smithing('ae2:64k_crafting_storage', 'kubejs:silicon_template', 'kubejs:silicon_machine', 'ae2:cell_component_64k').id('bttk:silicon_machine/64k_cpu_crafting_storage')
        event.smithing('ae2:256k_crafting_storage', 'kubejs:silicon_template', 'kubejs:silicon_machine', 'ae2:cell_component_256k').id('bttk:silicon_machine/256k_cpu_crafting_storage')
        event.smithing('ae2:crafting_accelerator', 'kubejs:silicon_template', 'kubejs:silicon_machine', 'ae2:engineering_processor').id('bttk:silicon_machine/cpu_crafting_accelerator')
        event.smithing('ae2:controller', 'kubejs:silicon_template', 'kubejs:silicon_machine', 'minecraft:copper_block').id('bttk:silicon_machine/controller')

        // Ender Age
        event.recipes.create.sequenced_assembly([
            Item.of('kubejs:ender_mechanism', 1)
        ], 'create:sturdy_sheet', [
            event.recipes.create.deploying(incompleteSiliconMechanism, [incompleteSiliconMechanism, 'create:powdered_obsidian']),
            event.recipes.create.deploying(incompleteSiliconMechanism, [incompleteSiliconMechanism, 'thermal:quartz_gear']),
            event.recipes.create.deploying(incompleteSiliconMechanism, [incompleteSiliconMechanism, 'thermal:quartz_gear']),
            event.recipes.create.deploying(incompleteSiliconMechanism, [incompleteSiliconMechanism, 'minecraft:ender_eye']),
            event.recipes.create.deploying(incompleteSiliconMechanism, [incompleteSiliconMechanism, 'minecraft:ender_eye']),
            event.recipes.create.pressing(incompleteSiliconMechanism, [incompleteSiliconMechanism])
        ]).transitionalItem(incompleteEnderMechanism).loops(1).id('bttk:sequenced_assembly/mechanism/ender_mechanism')
    
        event.recipes.create.item_application('kubejs:ender_casing', ['kubejs:silicon_casing', 'kubejs:obsidian_ingot']).id('bttk:item_application/ender_casing')
    
        event.shaped('4x kubejs:ender_machine', [
            'ABA',
            'BCB',
            'ABA'
        ], {
            A: 'kubejs:ender_casing',
            B: 'kubejs:ender_mechanism',
            C: '#forge:glass'
        }).id('bttk:machines/ender_machine')

        event.shaped('2x kubejs:ender_template', [
            'ABA',
            'ACA',
            'AAA'
        ], {
            A: 'minecraft:diamond',
            B: 'kubejs:ender_template',
            C: 'kubejs:obsidian_ingot'
        }).id('bttk:ender_template_duplication')
        
        stonecutting('kubejs:ender_machine', 'kubejs:ender_template', 4)
        
        event.remove('createendertransmission:chunk_loader')
        event.remove('createendertransmission:item_transmitter')
        event.remove('createendertransmission:fluid_transmitter')
        event.remove('createendertransmission:energy_transmitter')
        event.smithing('createendertransmission:chunk_loader', 'kubejs:ender_template', 'kubejs:ender_machine', 'minecraft:beacon').id('bttk:ender_machine/chunk_loader')
        event.smithing('createendertransmission:item_transmitter', 'kubejs:ender_template', 'kubejs:ender_machine', 'create:smart_chute').id('bttk:ender_machine/item_transmitter')
        event.smithing('createendertransmission:fluid_transmitter', 'kubejs:ender_template', 'kubejs:ender_machine', ['create:fluid_tank', 'create_connected:fluid_vessel']).id('bttk:ender_machine/fluid_transmitter')
        event.smithing('createendertransmission:energy_transmitter', 'kubejs:ender_template', 'kubejs:ender_machine', 'create:rotation_speed_controller').id('bttk:ender_machine/energy_transmitter')
    })